<template>
  <div
      v-if="!loader.rightPanel && !Object.keys(application).length"
      class="advance-right-load"
  >
    Заявка не выбрана
  </div>
  <div
      v-else-if="loader.rightPanel && !Object.keys(application).length"
      class="advance-right-load"
  >
    <ob-loader
        :width="10"
        :height="10"
        :duration="2"
    />
  </div>
  <div v-else>
    <div class="advance-right-first">
      <div class="advance-right-first__header">
        <div class="advance-right-first__header-block">
          <span class="advance-right-first__header-advance">Заявка на аванс </span>
          <span
              class="advance-right-first__header-status"
              :class="[application.status === 'FULLY_PAID' ? 'success' : application.status === 'CANCELLED' ? 'warning' : '']"
          >
            {{showStatus(application.status)}}
          </span>
        </div>
        <ObMenuDropdown
          :items="dropdownTabs"
          class="disabled"
        />
      </div>

      <div class="advance-right-first__application">
        <div>
          № заказа:
          <span
              @click="$router.push(`order-item/${application.entityUuid}?is_suborder=true`)"
              style="cursor: pointer"
          >
            {{application.entityNumber}}
          </span>
        </div>
        <div>
          Дата подписания заявки на перевозку:
          <span>{{application.docsConfirmedAt | date('DD.MM.YYYY, HH:mm')}}</span>
        </div>
        <div>
          Заказчик:
          <span>{{application.clientName}}</span>
        </div>
        <div v-if="application.contractorName">
          Перевозчик:
          <span>{{application.contractorName}}</span>
        </div>
        <div>
          Загружен в УНФ:
          <span>{{application.docsSendedTo1CAt ? 'Да' : 'Нет'}}</span>
        </div>
        <div>
          Оплачен:
          <span>{{application.paidAt ? 'Да' : 'Нет'}}</span>
        </div>
        <div v-if="application.paidAt">
          Дата оплаты:
          <span>{{application.paidAt | date('DD.MM.YYYY, HH:mm')}}</span>
        </div>
      </div>
    </div>

    <div class="advance-right-second">
      <div class="advance-right-second__vat">
        <span>Аванс с учетом НДС</span>
        <span>{{transformRubles(application.advanceWithNds) | currency}} ₽</span>
      </div>
      <div class="advance-right-second__amount">
        <span>Стоимость перевозки с учетом НДС</span>
        <span>{{transformRubles(application.totalPrice) | currency}} ₽</span>
      </div>
      <div class="advance-right-second__amount">
        <span>Сбор за оформление документов с учетом НДС</span>
        <span>{{transformRubles(application.docServicePrice) | currency}} ₽</span>
      </div>
    </div>

    <div class="advance-right-three">
      <div v-show="application.fioContractor" class="advance-right-three__executor">Контактные данные Исполнителя</div>
      <div class="advance-right-three__name">{{application.fioContractor}}</div>
      <div class="advance-right-three__phone">{{application.phoneContractor}}</div>
      <div class="advance-right-three__email">{{application.emailContractor}}</div>
      <div v-show="application.driverFio" class="advance-right-three__executor">Данные водителя</div>
      <div class="advance-right-three__name">{{application.driverFio}}</div>
      <div class="advance-right-three__email">{{application.driverPhone}}</div>
    </div>

    <div class="advance-right-four">
      <div v-if="application.status === 'NEW'" class="advance-right-four__block driver">
        <ob-switcher
            labelRight="Водитель загружен "
            v-model="application.isDriverLoaded"
            @on-change="switcher"
            :is-disabled="blockForDriver"

        />
        <ob-tooltip content="Это текст о водителе">
          <i class="icon question"/>
        </ob-tooltip>
      </div>

      <div
          v-else-if="application.status === 'IN_PROCESS' || application.status === 'FULLY_PAID'"
          class="advance-right-four__block confirm"
      >
        <i class="icon double-checked"/>
        <div class="advance-right-four__block-info">
          <p>Водитель загружен</p>
          <span>Отмечено: {{application.driverLoadedCheckedAt | date('DD.MM.YYYY, HH:mm')}}</span>
        </div>
      </div>
      <ob-alert
          v-else-if="application.status === 'CANCELLED'"
          text="Заявка аннулирована системой по причине: Отмена заказа Клиентом"
          :hide-close-button="true"
          icon="alert"
          theme="danger"
      />
    </div>

    <div v-if="application.invoiceNumber" class="advance-right-five">
      <b>Документы об оплате</b>
      <p>№ на платформе: <span>{{application.invoiceNumber}}</span></p>
      <p v-if="application.paymentNumber">
        № документа в УНФ: <span>{{application.paymentNumber}}</span>
      </p>
    </div>

    <div v-if="application.status === 'NEW'" class="advance-right-six">
      <ob-button
          label="Отправить в 1С"
          :disabled="!application.isDriverLoaded"
          @click.once="changeStatusAdvance('ADVANCED')"
      />
      <ob-button
          label="Аннулировать"
          :disabled="blocker"
          @click="$emit('canceledApplication')"
      />
    </div>
  </div>
</template>

<script>
  import ObLoader from "common-components/src/obComponents/obLoader";
  import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown/index";
  import obSwitcher from "common-components/src/obComponents/obSwitcher";
  import ObTooltip from "common-components/src/obComponents/obTooltip";
  import ObAlert from "common-components/src/obComponents/obAlert";
  import ObButton from "common-components/src/obComponents/obButton";
  import {mapGetters, mapActions} from 'vuex';
  import transformer from "../../account/transformer";

  export default {
    name: "right",
    components: {
      ObLoader,
      ObMenuDropdown,
      obSwitcher,
      ObTooltip,
      ObAlert,
      ObButton
    },
    mixins: [transformer],
    data() {
      return {
        dropdownTabs: [
          {
            title: 'История авансирования',
            method: () => this.$emit('showHistory')
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        application: 'advances/application',
        loader: 'advances/loader',
        blocker: 'advances/blocker',
        blockForDriver: 'advances/blockForDriver',
      })
    },
    methods: {
      ...mapActions({
        changeStatusAdvance: 'advances/changeStatusAdvance'
      }),
      showStatus(status) {
        switch (status) {
          case 'IN_PROCESS':
            return 'НЕОПЛАЧЕНО';
          case 'NEW':
            return 'В РАБОТЕ';
          case 'FULLY_PAID':
            return 'ОПЛАЧЕНО';
          case 'CANCELLED':
            return 'АННУЛИРОВАНО';
          default:
            return '';
        }
      },
      async switcher() {
        await this.changeStatusAdvance(this.application.isDriverLoaded ? 'DRIVER_LOADED'  : 'DRIVER_NOT_LOADED')
      }
    }
  }
</script>

<style scoped lang="scss">
  .advance-right {
    &-load {
      display: flex;
      align-items: center;
      justify-content: center;
      height: 100%;
      font-size: 24px;
      line-height: 29px;
      letter-spacing: .4px;
      color: $color-grey-span;
    }
    &-first {
      border-bottom: 1px solid $color-grey-border;
      padding-bottom: 20px;
      &__header {
        display: flex;
        justify-content: space-between;

        &-block {
          position: relative;
          margin-bottom: 10px;
        }

        &-advance {
          font-size: 24px;
          line-height: 36px;
          letter-spacing: 0.4px;
          color: $color-text-base;
          margin-right: 10px;
        }

        &-status {
          font-size: 10px;
          line-height: 20px;
          letter-spacing: 0.4px;
          text-transform: uppercase;
          color: $gray-slate;
          position: absolute;
          width: 100%;

          &.success {
            color: $green-800;
          }

          &.warning {
            color: $color-error;
          }
        }
      }
      &__application {
        color: $gray-slate;
        font-size: 13px;
        letter-spacing: 0.2px;
        div {
          margin-bottom: 10px;
          span {
            color: $color-text-base;
          }
          &:first-child {
            span {
              color: $color-blue-navy-blue;
            }
          }
        }
      }
    }
    &-second {
      mix-blend-mode: normal;
      letter-spacing: 0.4px;
      padding: 20px 0 10px;
      border-bottom: 1px solid $color-grey-border;
      &__vat {
        font-weight: bold;
        font-size: 16px;
        line-height: 20px;
        color: $color-text-base;

      }
      &__amount {
        font-size: 14px;
        line-height: 18px;
        color: $gray-slate;
      }
      &__vat, &__amount {
        display: flex;
        justify-content: space-between;
        margin-bottom: 10px;
      }
    }
    &-three {
      padding: 20px 0;
      &__executor {
        font-size: 13px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $gray-slate;
      }
      &__name,  &__phone, &__email {
        font-size: 14px;
        line-height: 20px;
        letter-spacing: 0.4px;
      }
      &__name {
        color: $color-text-base;
      }
      &__phone, &__email {
        color: $color-blue-navy-blue;
      }
    }
    &-four {
      &__block {
        &.driver {
          padding: 23px 20px;
        }
        &.confirm {
          padding: 10px 22px;
          display: flex;
          align-items: center;
        }
        background: rgba(0, 178, 144, 0.15);
        border: 1px solid rgba(0, 178, 144, 0.15);

        i.question {
          margin-left: 5px;
          cursor: pointer;
          color: $color-blue-navy-blue;
          font-size: 17px;
        }

        i.double-checked {
          color: $deep-blue;
          margin-right: 12px;
          font-size: 22px;
        }
        &-info {
          color: $color-text-base;
          line-height: 20px;
          letter-spacing: 0.4px;
          p {
            font-size: 16px;
          }
          span {
            font-size: 12px;
          }
        }
      }
    }
    &-five {
      padding: 20px 0 0;
      line-height: 20px;
      b {
        font-size: 16px;
        letter-spacing: 0.4px;
        color: $color-text-base;
      }
      p {
        font-size: 13px;
        letter-spacing: 0.2px;
        color: $gray-slate;
        margin-top: 10px;
        &:nth-child(3n) {
          margin-top: 0;
        }
        span {
          color: $color-text-base;
        }
      }
    }
    &-six {
      padding: 20px 0 0;
      display: flex;
      button {
        border-radius: 10px;
        &:last-child {
          margin-left: 10px;
          background: transparent !important;
        }
      }
    }
    .disabled {
      opacity: 0.6;
      pointer-events: none;
    }
  }
</style>

<style lang="scss">
  .advance-right-six {
    button {
      &:last-child {
        span {
          color: $color-error !important;
        }
      }
    }
  }
</style>
